<template>
  <div
    class="ob-switcher-checkbox-container switcher-wrapper"
    :class="{ 'disabled': disabled, 'readonly': readonly, 'dark-theme': dark }"
  >
    <label>
      <input
        data-attr="ob-switcher-checkbox-container"
        type="checkbox"
        :disabled="disabled || readonly"
        :checked="value"
        :data-qa="dataQa"
        @change="$emit('change', $event.target.checked)"
      >
      <div class="switch-box">
        <div class="switch-button" />
      </div>
      {{ label }}
    </label>
  </div>
</template>
<script>
export default {
  name: 'ObSwitcherCheckbox',
  model: {
    event: 'change'
  },
  props: {
    value: {
      type: Boolean,
      required: true
    },
    label: {
      type: String
    },
    disabled: {
      type: Boolean,
      default: () => false
    },
    readonly: {
      type: Boolean,
      default: () => false
    },
    dark: {
      type: Boolean,
      default: () => false
    },
    dataQa: {
      type: String
    }
  }
}
</script>
<style lang="scss" scoped>
  $transition-timing: .2s cubic-bezier(.645,.045,.355,1);

  label {
    display: inline-flex;
    align-items: center;
    user-select: none;
    cursor: pointer;
    font-family: "Roboto", sans-serif;
    font-size: 16px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-text-base;
    transition: $transition-timing;
  }

  .ob-switcher-checkbox-container {
    &.switcher-wrapper {
      display: inline-flex;
      align-items: center;

      &.dark-theme {
        .switch-box {
          background: $obSwitcherCheckbox-background_dark_switch_box;
          box-shadow: inset 0px 0px 4px rgba($color-blue-navy-blue, 0.48);
        }

        .switch-button {
          background: $obSwitcherCheckbox-background_dark_switch_button;
          box-shadow: 0px 1px 1px $obSwitcherCheckbox-box_shadow_dark_switch_button;
        }
      }

      &.disabled {
        pointer-events: none;

        label {
          color: $color-grey-border;
        }

        .switch-box {
          box-shadow: none;
          background: $color-light-grey;
        }

        .switch-button {
          box-shadow: none;
        }

        input:checked {
          + .switch-box .switch-button {
            box-shadow: none;
          }
        }
      }

      &.readonly {
        label {
          cursor: default;
        }

        .switch-box {
          box-shadow: none;
          background: $color-light-grey;
        }
      }
    }

    .switch-box {
      width: 28px;
      height: 14px;
      border-radius: 16px;
      background: $background-color-light;
      margin-right: 8px;
      transition: $transition-timing;
      box-shadow: inset 0px 0px 4px $obSwitcherCheckbox-switch_box_shadow;
    }

    .switch-button {
      width: 16px;
      height: 16px;
      border-radius: 50%;
      position: relative;
      top: -1px;
      transition: $transition-timing;
      background: $obSwitcherCheckbox-background_switch_button;
      box-shadow: 0px 1px 1px rgba($deep-blue, 0.28);
    }

    input {
      margin: 0;
      padding: 0;
      width: 0;
      height: 0;
      opacity: 0;
      background: transparent;
      position: absolute;

      &:checked {
        + .switch-box {
          box-shadow: inset 0px 0px 4px rgba($color-blue-navy-blue, 0.48);

          .switch-button {
            transform: translate3d(calc(28px - 100%), 0, 0);
            background: $color-blue-navy-blue;
            box-shadow: 2px 1px 4px rgba($color-blue-navy-blue, 0.6);
          }
        }
      }
    }
  }

</style>
